local e=require"luci.http"
module("luci.controller.istorego",package.seeall)
function index()
if nixio.fs.access("/usr/lib/lua/luci/view/istorego/main.htm")then
entry({"admin","istorego"},call("istorego_index"),_("iStoreGo"),32).leaf=true
end
entry({"admin","istorego_api","containers"},call("istorego_api_containers"))
entry({"admin","istorego_api","images"},call("istorego_api_images"))
entry({"admin","istorego_api","install"},call("istorego_api_install"))
entry({"admin","istorego_api","uninstall"},call("istorego_api_uninstall"))
entry({"admin","istorego_api","restart"},call("istorego_api_restar"))
entry({"admin","istorego_api","start"},call("istorego_api_start"))
entry({"admin","istorego_api","stop"},call("istorego_api_stop"))
entry({"admin","istorego_api","pull"},call("istorego_api_pull"))
entry({"admin","istorego_api","logs"},call("istorego_api_logs"))
end
function istorego_index()
luci.template.render("istorego/main",{
prefix=luci.dispatcher.build_url(unpack({"admin","istorego"}))
})
end
function istorego_api_images()
local e=require"luci.http"
e.prepare_content("application/json")
local e=e.getenv("REQUEST_METHOD")
local e;
e=luci.util.exec("docker images --format '{{json . }}'")
local e={
success=0,
result=e,
}
luci.http.write_json(e)
end
function istorego_api_containers()
local e=require"luci.http"
e.prepare_content("application/json")
local e=e.getenv("REQUEST_METHOD")
local e;
e=luci.util.exec("docker ps -a --format '{{json . }}'")
local e={
success=0,
result=e,
}
luci.http.write_json(e)
end
local function e(e,n)
local t=require"nixio"
local i=require"os"
local a=require"nixio.fs"
local h=t.bit.rshift
local o=t.open_flags("wronly","creat")
local t,s,o=t.open("/var/lock/istorego.lock",o)
if not t then
return 255,"","Open lock failed: "..o
end
local s,r,o=t:lock("tlock")
if not s then
t:close()
return 255,"","Lock failed: "..o
end
if n then
e="/etc/init.d/tasks task_add istorego "..luci.util.shellquote(e)
end
local o=i.execute(e.." >/var/log/istorego.stdout 2>/var/log/istorego.stderr")
local e=a.readfile("/var/log/istorego.stderr")
local i=a.readfile("/var/log/istorego.stdout")
a.unlink("/var/log/istorego.stderr")
a.unlink("/var/log/istorego.stdout")
t:lock("ulock")
t:close()
e=e or""
if o==256 and e==""then
e="os.execute exit code 1"
end
return h(o,8),i or"",e or""
end
function istorego_api_install()
local t=require"luci.http"
t.prepare_content("application/json")
local a=t.getenv("REQUEST_METHOD")
local o="";
if a=="post"or a=="POST"then
local a=t.content()
local t=require"luci.jsonc"
local t=t.parse
local t=t(a)
if t==nil or next(t)==nil then
luci.http.write_json({
error="invalid request"
})
return
end
if t.name==nil then
luci.http.write_json({
error="not found name"
})
return
end
if t.cmds==nil then
luci.http.write_json({
error="not found cmds"
})
return
end
local t="docker run -d --name=iStore_"..t.name.." "..table.concat(t.cmds," ")
o=t
local e,a,t=e(t,true)
if e~=0 then
luci.http.write_json({
success=-1,
error=t,
})
return
end
end
local e={
success=0,
result=luci.util.shellquote(o),
}
luci.http.write_json(e)
end
function istorego_api_uninstall()
local t=require"luci.http"
t.prepare_content("application/json")
local a=t.getenv("REQUEST_METHOD")
if a=="post"or a=="POST"then
local a=t.content()
local t=require"luci.jsonc"
local t=t.parse
local t=t(a)
if t==nil or next(t)==nil then
luci.http.write_json({
error="invalid request"
})
return
end
if t.id~=nil then
local a="";
if t.force~=nil and t.force==true then
a="-f "
end
local t,a,e=e("docker rm "..a..t.id,true)
if t~=0 then
luci.http.write_json({
error=e,
})
return
end
end
end
local e={
success=0,
}
luci.http.write_json(e)
end
function istorego_api_start()
local t=require"luci.http"
t.prepare_content("application/json")
local a=t.getenv("REQUEST_METHOD")
if a=="post"or a=="POST"then
local t=t.content()
local a=require"luci.jsonc"
local a=a.parse
local t=a(t)
if t==nil or next(t)==nil then
luci.http.write_json({
error="invalid request"
})
return
end
if t.id~=nil then
local t,a,e=e("docker start "..t.id,true)
if t~=0 then
luci.http.write_json({
error=e,
})
return
end
end
end
local e={
success=0,
}
luci.http.write_json(e)
end
function istorego_api_restart()
local t=require"luci.http"
t.prepare_content("application/json")
local a=t.getenv("REQUEST_METHOD")
if a=="post"or a=="POST"then
local a=t.content()
local t=require"luci.jsonc"
local t=t.parse
local t=t(a)
if t==nil or next(t)==nil then
luci.http.write_json({
error="invalid request"
})
return
end
if t.id~=nil then
local t,a,e=e("docker restart "..t.id,true)
if t~=0 then
luci.http.write_json({
error=e,
})
return
end
end
end
local e={
success=0,
}
luci.http.write_json(e)
end
function istorego_api_stop()
local t=require"luci.http"
t.prepare_content("application/json")
local a=t.getenv("REQUEST_METHOD")
if a=="post"or a=="POST"then
local t=t.content()
local a=require"luci.jsonc"
local a=a.parse
local t=a(t)
if t==nil or next(t)==nil then
luci.http.write_json({
error="invalid request"
})
return
end
if t.id~=nil then
local t,a,e=e("docker stop "..t.id,true)
if t~=0 then
luci.http.write_json({
error=e,
})
return
end
end
end
local e={
success=0,
}
luci.http.write_json(e)
end
function istorego_api_logs()
local t=require"luci.http"
t.prepare_content("application/json")
local a=t.getenv("REQUEST_METHOD")
if a=="post"or a=="POST"then
local t=t.content()
local a=require"luci.jsonc"
local a=a.parse
local t=a(t)
if t==nil or next(t)==nil then
luci.http.write_json({
error="invalid request"
})
return
end
if t.id~=nil then
local e,a,t=e("docker logs "..t.id,true)
if e~=0 then
luci.http.write_json({
error=t,
})
return
end
end
end
local e={
success=0,
}
luci.http.write_json(e)
end
function istorego_api_pull()
local t=require"luci.http"
t.prepare_content("application/json")
local a=t.getenv("REQUEST_METHOD")
if a=="post"or a=="POST"then
local a=t.content()
local t=require"luci.jsonc"
local t=t.parse
local t=t(a)
if t==nil or next(t)==nil then
luci.http.write_json({
error="invalid request"
})
return
end
if t.image~=nil then
local e,a,t=e("docker pull "..t.image,true)
if e~=0 then
luci.http.write_json({
error=t,
})
return
end
end
end
local e={
success=0,
}
luci.http.write_json(e)
end